﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace TreeViewAutoScroll
{
    public partial class Form1 : Form
    {
        private RadTreeView treeView;

        public Form1()
        {
            InitializeComponent();

            this.treeView = new MyTree
            {
                Parent = this,
                Dock = DockStyle.Fill
            };

            this.treeView.ShowNodeToolTips = true;
            this.treeView.ToolTipTextNeeded += treeView_ToolTipTextNeeded;

            for (int i = 0; i < 15; i++)
            {
                this.treeView.Nodes.Add(new string((char)('a' + i), 50));
                for (int j = 0; j < 10; j++)
                {
                    RadTreeNode node = this.treeView.Nodes.Last();
                    node.Nodes.Add(new string((char)(node.Text[0] + j + 1), 50 + j));
                }
            }
        }

        void treeView_ToolTipTextNeeded(object sender, Telerik.WinControls.ToolTipTextNeededEventArgs e)
        {
            if (sender is TreeNodeElement)
            {
                e.ToolTipText = (sender as TreeNodeElement).Data.Text;
            }
        }

        public class MyTree : RadTreeView
        {
            protected override RadTreeViewElement CreateTreeViewElement()
            {
                return new MyTreeViewElement();
            }

            public override string ThemeClassName
            {
                get
                {
                    return typeof(RadTreeView).FullName;
                }
                set
                {
                }
            }
        }

        public class MyTreeViewElement : RadTreeViewElement
        {
            protected override void EnsureNodeVisibleHorizontal(RadTreeNode node, TreeNodeElement nodeElement)
            {
                //we stop the base logic here
            }

            protected override Type ThemeEffectiveType
            {
                get
                {
                    return typeof(RadTreeViewElement);
                }
            }
        }
    }
}
